unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ScktComp, StdCtrls, ComCtrls;
  const maxmemolines=20;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    ClientSocket1: TClientSocket;
    ServerSocket1: TServerSocket;
    SpeedButton1: TSpeedButton;
    StatusBar1: TStatusBar;
    procedure Form1Create(Sender: TObject);
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Form1Close(Sender: TObject; var Action: TCloseAction);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure Memo2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Memo1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    server:string;
    clientname:string;
    IsServer:boolean;
    talk:boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Form1Create(Sender: TObject);
begin
memo1.lines.clear;
memo2.lines.clear;
talk:=false;
 try
serversocket1.active:=true;
clientsocket1.active:=false;
IsServer:=true;
statusbar1.panels[1].text:=' I am server ';
 except
serversocket1.active:=false;
IsServer:=false;
statusbar1.panels[1].text:=' I am client ';
        end;


end;

procedure TForm1.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 statusbar1.panels[2].text:=' Client connected';
 if not talk then
 talk:=true else   begin
 serversocket1.socket.connections[1].sendtext(' I am Busy ');
 serversocket1.socket.connections[1].Close;
 end;
// socket.sendtext('Welcome to Sasha PopUp');
 memo2.setfocus;
end;

procedure TForm1.Form1Close(Sender: TObject; var Action: TCloseAction);
begin
serversocket1.close;
end;

procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
  var
  i:integer;
  s:string;
begin
   s:=socket.receivetext;
   memo1.lines.add(s);
  { with serversocket1.socket do
    for i:=1 to activeconnections do begin
     if connections[i-1].handle <> socket.handle
       then
       connections[i-1].sendtext(s);
       end;
   if memo1.lines.count>maxmemolines then
    memo1.lines.delete(0);}
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
if clientsocket1.active then clientsocket1.active:=false;
if inputquery('Connect to server','IP address:',server)
  then
   begin
    with clientsocket1 do
     begin
     IsServer:=false;
      serversocket1.active:=false;
      address:=server;
      active:=true;
      statusbar1.panels[1].text:=' I am client';
      end;
      memo2.lines.clear;
      end;
end;

procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   statusbar1.panels[2].text:=
   'I connected to server';//+Socket.remotehost;
end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
begin
memo1.lines.add(socket.receivetext);
end;

procedure TForm1.Memo2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if (key=vk_return) //and (length(memo1.lines[
 // memo1.lines.count-1])>0)
   then begin
   if (length(clientname)<=0) then  begin
   inputquery('Registration','Your nickname:',clientname);  end;
    memo1.lines.add(clientname+':'+memo2.lines[memo2.lines.count-1]);
   if IsServer then
  serversocket1.socket.connections[0].sendtext(clientname+': '+memo2.lines
   [memo2.lines.count-1])
   else
   clientsocket1.socket.sendtext(clientname+': '+memo2.lines
   [memo2.lines.count-1]);
    memo2.lines.clear;
   end;
end;

procedure TForm1.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin

memo2.lines.add('Connection to '+server+' failed');
errorcode:=0;

end;

procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   try
serversocket1.active:=true;
clientsocket1.active:=false;
IsServer:=true;
statusbar1.panels[1].text:=' I am server ';
 except
serversocket1.active:=false;
IsServer:=false;
statusbar1.panels[1].text:=' I am client ';
        end;
end;

procedure TForm1.Memo1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
memo2.setfocus;
end;

end.
